@echo off
cls

set TCGINA_FILE_VERSION=121

call "%~dp0clean"

set TOOLS=%~dp0tools
call "%TOOLS%\map"

md release >NUL 2>NUL
md release\install >NUL 2>NUL
md release\kfedit >NUL 2>NUL
md release\tcuser >NUL 2>NUL
md release-x64 >NUL 2>NUL
md release-x64\install >NUL 2>NUL
md release-x64\kfedit >NUL 2>NUL
md release-x64\tcuser >NUL 2>NUL

call :build_all kfedit kfedit r exe kfedit
call :build_all reg reg r exe tcuser
call :build_all setup setup r exe install
call :build_all tcgina tcgina r dll install\tcgf%TCGINA_FILE_VERSION%.bin install\tcgf%TCGINA_FILE_VERSION%-x64.bin
call :build_all tcgina tcgina c dll install\tcgd%TCGINA_FILE_VERSION%.bin install\tcgd%TCGINA_FILE_VERSION%-x64.bin
call :build_all tcgina tcgina-lite r dll install\tcgl%TCGINA_FILE_VERSION%.bin install\tcgl%TCGINA_FILE_VERSION%-x64.bin

call :build repsha1 repsha1 r win32
"%TARGETPATH%\repsha1" src\setup\setup.ini "release\install\setup.ini"
"%TARGETPATH%\repsha1" src\setup\setup-x64.ini "release-x64\install\setup.ini"

call "%TOOLS%\map" /d

goto :eof

:build_all
set NAMEX64=%6
if "%NAMEX64%" equ "" set NAMEX64=%5
call :build %1 %2 %3 win32 %4 "release\%5"
call :build %1 %2 %3 x64 %4 "release-x64\%NAMEX64%"
goto :eof

:build
echo.Compiling %2 (%3/%4)...
call "%TOOLS%\build_vs" %3 %4 %1 %2
if "%~6" equ "" goto :eof
copy "%TARGETPATH%\%2.%5" "%~6" >NUL 2>NUL
goto :eof
